/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2014-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *  
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: target_rc_car.h 20 2015-04-20 14:29:19Z honda $
 */

/*
 *		ɥ饤ФؤΥ󥿥ե
 */

#ifndef TARGET_DRIVER_IF_H
#define TARGET_DRIVER_IF_H

#include "hsbrh850f1l_device.h"

/*
 *  ܥǥϤν
 */
extern void tInitBody(void);

/*
 *  tSetEachLEDǻؼ
 */
#define WINKER_L_NO		0
#define WINKER_R_NO		1
#define BREAK_LAMP_NO	2
#define HEAD_LAMP_NO	3
#define FOG_LAMP_NO		4
#define BACK_LAMP_NO	5

/*
 *  ̤LEDѥޥ
 */
#define WINKER_L_SET(on)		tSetEachLED(WINKER_L_NO, (on))
#define WINKER_R_SET(on)		tSetEachLED(WINKER_R_NO, (on))
#define HEAD_LAMP_SET(on)		tSetEachLED(HEAD_LAMP_NO,  (on))
#define FOG_LAMP_SET(on)		tSetEachLED(FOG_LAMP_NO, (on))
#define BRAKE_LAMP_SET(on)		tSetEachLED(BREAK_LAMP_NO, (on))
#define BACK_LAMP_SET(on)		tSetEachLED(BACK_LAMP_NO, (on))

/*
 *  ̤LED
 */
extern void tSetEachLED(uint8 no, boolean on);

/*
 *  LED
 */
extern void tSetLED(uint32 pattern);

/*
 *  ֥Υå
 */
extern void tSetBuzzer(boolean onoff);

/*
 *  SDBDT³UARTν
 */
extern void tInitSBDBTUart(void);

/*
 *  SDBDT³UARTμ
 */
extern boolean tReceiveSBDBTUart(unsigned char *p_str, uint32 len);

/*
 *  SDBDT³UARTؤ
 */
extern boolean tSendSBDBTUart(unsigned char *p_str);

/*
 *  PWMϢν
 */
extern void tInitPWM(uint32 cycle_us, uint32 servo_duty_us, uint32 esc_duty_us);

/*
 *  ܤΥǥ塼ƥѹ
 */
extern void tChangeServoDuty(uint32 servo_duty_us);

/*
 *  ESCΥǥ塼ƥѹ
 */
extern void tChangeESCDuty(uint32 esc_duty_us);

/*
 *  ESCΥǥ塼ƥѹ
 */
extern void tChangeESCDuty100NS(uint32 esc_duty_100ns);

#endif /* TARGET_DRIVER_IF_H */
